package amigosStruts.datos;

import amigosStruts.beans.Usuario;
import amigosStruts.BDException;
import amigosStruts.Constantes;
import java.sql.*;
import java.util.*;
import java.text.*;

public class UsuarioBD {
	private FuenteDatos fuente = null;
  
	public UsuarioBD() throws BDException {
	   fuente = FuenteDatos.obtFuente();
	}

	public void crearUsuario(Usuario usuario) throws BDException {
	   ResultSet res;
	   Connection con;
	   Statement sql;
	   String sqlCad;
	   java.sql.Date fechaNacSQL;

	   con = fuente.obtConexion();
	   try {
		   sql = con.createStatement();
		   fechaNacSQL = new java.sql.Date(usuario.getFechaNac().getTime());
		   sqlCad = "INSERT INTO usuarios VALUES ('" + usuario.getLogin() + "'" +
					",'" + usuario.getPassword() + "'" + ",'" + usuario.isVaron() + "'"
					+ ",'" + fechaNacSQL.toString() + "'" 
					+ ",'" + usuario.getLocalidad() + "'" 
					+ ",'" + usuario.getDescripcion() + "'" + ")";
		   System.out.println(sqlCad);
		   sql.executeUpdate(sqlCad);
	   }
	   catch(SQLException e) {
	   	  throw new BDException("Problema al insertar usuario en la B.D.", e);
	   }	   
	}

  
	public Usuario buscar(String login) throws BDException {
	   ResultSet res;
	   Connection con;
	   Statement sql;

       try {
		   con = fuente.obtConexion();
		   sql = con.createStatement();
		   res = sql.executeQuery("SELECT * from usuarios WHERE login='" + login + "'");
		   if (res.next())
			  return crearBeanUsuario(res);
		   else
			  return null;
	   }
	   catch(SQLException e) {
		   throw new BDException("Problema al buscar usuario en la B.D.", e);
	   }
	}

	public Usuario[] buscar(int edadMin, int edadMax, String localidad, int sexo) throws BDException {
	   java.util.Date ahora, fechaInicio, fechaFin;
	   GregorianCalendar cal;
	   String fechaInicioCad, fechaFinCad;
	   SimpleDateFormat df;
	   ResultSet res;
	   Connection con;
	   String sqlCad;
	   Statement sql;
	   ArrayList usuarios;
     
	   df = new SimpleDateFormat("yyyy-MM-dd");

	   //calcular fechas mnima y mxima teniendo en cuenta la edad deseada
	   cal = new GregorianCalendar();
	   //fecha minima (edad mxima)
	   cal.setTime(new java.util.Date());
	   cal.set(GregorianCalendar.YEAR, cal.get(GregorianCalendar.YEAR)-edadMax);
	   fechaInicio = cal.getTime();
	   //fecha mxima (edad mnima)
	   cal.setTime(new java.util.Date());
	   cal.set(GregorianCalendar.YEAR, cal.get(GregorianCalendar.YEAR)-edadMin);
	   fechaFin = cal.getTime();
	   //pasar las fechas a formato aaaa-mm-dd para utilizarlas en SQL
	   fechaInicioCad = df.format(fechaInicio);
	   fechaFinCad = df.format(fechaFin);
	   sqlCad = "SELECT * from usuarios WHERE fechaNac>='" + fechaInicioCad +
			 "' AND fechaNac<= '" + fechaFinCad + "'";
	   //bsqueda por localidad      
	   if (localidad!=null)
		  sqlCad = sqlCad + "AND localidad='" + localidad + "'";
	   //bsqueda por sexo
	   if (sexo!=Constantes.SEXO_INDIFERENTE)
		  sqlCad = sqlCad + "AND sexo='" + sexo + "'";
	   System.out.println(sqlCad);
	   con = fuente.obtConexion();
	   try {
		   sql = con.createStatement();
		   res = sql.executeQuery(sqlCad);
		   usuarios = new ArrayList();
		   while (res.next())         
			  usuarios.add(crearBeanUsuario(res));
		   }
	   catch(SQLException e) {
	   	  throw new BDException("Problema al buscar usuario en la B.D.", e); 
	   }
	   return (Usuario[]) usuarios.toArray(new Usuario[0]);         
    
	}
  
	private Usuario crearBeanUsuario(ResultSet datos) throws SQLException {
	   Usuario usuario;

	   usuario = new Usuario();
	   usuario.setLogin(datos.getString("login"));
	   usuario.setPassword(datos.getString("password"));
	   usuario.setFechaNac(datos.getDate("fechaNac"));
	   usuario.setLocalidad(datos.getString("localidad"));
	   usuario.setVaron(datos.getBoolean("varon"));
	   usuario.setDescripcion(datos.getString("descripcion"));
	   return usuario;
	}

	
}